new;

cls;

/*
** Simulation d'une matrice 1000*3 de chi2(1)
*/

r = 1000;
c = 3;

x = rndn(r,c);
chi2 = x^2;

print meanc(chi2)~stdc(chi2);

/*
** Simulation d'une matrice 1000*3 de chi2(5)
**
** en utilisant une boucle
*/

nu = 5;
chi2 = zeros(r,c);

for i (1,c,1);
  chi2[.,i] = sumc(rndn(nu,r)^2);
endfor;

print meanc(chi2)~stdc(chi2);

/*
** Simulation d'une matrice 1000*3 de chi2(5)
**
** en utilisant la commande reshape
*/

rndseed 123;
chi2 = reshape(sumc(rndn(nu,r*c)^2),r,c);

print meanc(chi2)~stdc(chi2);

/*
** Simulation d'une matrice 1000*3 de chi2(5)
**
** en utilisant les tableaux multidimensionnels
*/

rndseed 123;
x = rndn(r*c*nu,1); 
orders = nu|r|c; 

y = areshape(x,orders); 
y = y .* y;

chi2 = arraytomat(asum(y,3));
print meanc(chi2)~stdc(chi2);









