/*
**  The Tobit Model with Inequality/Equality Constraints
**
*/

new;
library co,optmum;
coset;
optset;

data = loadd("tobit");
y = data[.,1];
x = data[.,2 3 4];

proc loglProc(theta);
  local beta,sigma2,xb,e,u,logl1,logl2,logl;

  beta = theta[1:3];
  sigma2 = theta[4]^2;

  xb = x*beta;
  e = y ./= 0;
  u = y - xb;

  logl1 = -0.5*ln(2*pi) -0.5*ln(sigma2) - 0.5*(u.*u)/sigma2;
  logl2 = lncdfnc(xb/sqrt(sigma2));
  logl = e .* logl1 + (1-e) .* logl2;

  retp(logl);
endp;

proc mlProc(theta);
  retp( - sumc(loglProc(theta)) );
endp;

let sv = 1 1 1 1;

{theta1,logl1,g1,retcode} = optmum(&mlProc,sv);

_co_C = { 1 1 0 0 };
_co_D = { 0 };
_co_Bounds = { -10 10,
                -10 10,
                -10 10,
                .01 10 };

{theta2,logl2,g2,retcode} = co(&mlProc,sv);

_co_A = { 1 1 -1 0 };
_co_B = { 0 };
let _co_C = . ;
let _co_D = . ;

sv = theta2;

{theta3,logl3,g3,retcode} = co(&mlProc,sv);



