new;
library pgraph;

rndseed 123;

alpha0 = 0.5;
alpha1 = 0.25;
beta1 = 0.65;

N = 1000;
Ns = 1;

t = seqa(1,1,N);

u = zeros(N,Ns);
h2 = zeros(N,Ns);

i = 1;
do until i > N;
  if i == 1;
    h2[i,.] = alpha0 / (1 - alpha1 - beta1) .* ones(1,Ns);
  else;    
    h2[i,.] = alpha0 + alpha1 * u[i-1,.]^2 + beta1 * h2[i-1,.];
  endif;

  u[i,.] = sqrt(h2[i,.]) .* rndn(1,Ns);

  i = i + 1;
endo;

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  xtics(0,1000,100,10);
  xlabel("\214t");
  ylabel("\214h[2]]t[");
  title("Conditional variance");
  xy(t,h2);

  ylabel("u]t[");
  title("Garch Process");
  xy(t,u);