new;
library optmum;

rndseed 123456;

ns = 1000;
m = 1;
sigma = 2;
z = m + rndn(ns,1)*sigma;

save data_gmm = z;

proc Moments(theta);
  local beta,m,sigma,h1,h2;

  m = theta[1];
  sigma = sqrt(theta[2]^2);

  /* first moment E[z] = m */
  h1 = z - m;

  /* second moment var[z] = sigma^2 */
  h2 = h1.*h1 - sigma^2;

  retp(h1~h2);
endp;

proc gmm_(theta);
  local g;

  g = meanc(Moments(theta));
  
  retp( g'g );
endp;

let sv = .1 .2;

{theta,f,g,retcode} = optmum(&gmm_,sv);