new;
library optmum;

ns = 5000;
load z = data_gmm;

proc Moments(theta);
  local m,sigma,h1,h2,x;

  m = theta[1];
  sigma = sqrt(theta[2]^2);
  
  rndseed 123;
  x = m + sigma*rndn(ns,1);
  x = x + cdftci(rndu(ns,1),5);

  /* first moment */
  h1 = z - meanc(x);

  /* second moment */
  h2 = h1.*h1 - stdc(x)^2;

  retp(h1~h2);
endp;

proc gmm_(theta);
  local g;

  g = meanc(Moments(theta));
  
  retp( g'g );
endp;

let sv = .1 .2;

{theta,f,g,retcode} = optmum(&gmm_,sv);