new;
library optmum;

n = 100;
let beta = 1 2 3;
sigma = 2;

x = 100*rndu(n,3);
y = x*beta + sigma * rndn(n,1);

proc logl(theta);
  local b,sigma2,L,u;

  b = theta[1:3];
  sigma2 = theta[4]^2;

  u = y - x*b;
  L = -0.5*ln(2*pi) - 0.5*ln(sigma2) - 0.5*(u.*u)/sigma2;

  retp(L);
endp;

proc fmin(theta);
  retp( -sumc(logl(theta)) );
endp;

let sv = 1 1 1 1 ;

{theta_ml,f,g,retcode} = optmum(&fmin,sv);

b_ml = theta_ml[1:3];
sigma_ml = theta_ml[4];

H = -hessp(&fmin,theta_ml);
cov1_ml = invpd(-H);

J = gradp(&logl,theta_ml);
cov2_ml = invpd(J'J);

cov3_ml = invpd(-H)*(J'J)*invpd(-H);

stderr1_ml = sqrt(diag(cov1_ml));
stderr2_ml = sqrt(diag(cov2_ml));
stderr3_ml = sqrt(diag(cov3_ml));

print;
call printfmt(stderr1_ml~stderr2_ml~stderr3_ml,1); 
