new;
library optmum;

n = 1000;
let beta = 1 2 3;
sigma = 2;

x = 100*rndu(n,3);
z = rndu(n,1);
u = rndn(n,1);
sigma = 2 + .5 * z; 
y = x*beta + sigma .* u;

proc logl1(theta);
  local b,sigma2,L,u;

  b = theta[1:3];
  sigma2 = theta[4]^2;

  u = y - x*b;
  L = -0.5*ln(2*pi) - 0.5*ln(sigma2) - 0.5*(u.*u)/sigma2;

  retp(L);
endp;

proc fmin1(theta);
  retp( -sumc(logl1(theta)) );
endp;

let sv = 1 1 1 1 ;

{theta1_ml,f,g,retcode} = optmum(&fmin1,sv);

proc logl2(theta);
  local b,sigma,L,u;

  b = theta[1:3];
  sigma = sqrt(theta[4]^2) + sqrt(theta[5]^2) * z;

  u = y - x*b;
  L = -0.5*ln(2*pi) - 0.5*ln(sigma^2) - 0.5*(u^2)./(sigma^2);

  retp(L);
endp;

proc fmin2(theta);
  retp( -sumc(logl2(theta)) );
endp;

let sv = 1 1 1 1 1;

{theta2_ml,f,g,retcode} = optmum(&fmin2,sv);



