/*
**   The data are taken from Douglas M. Bates and Donald G. Watts,
**   Nonlinear Regression Analysis and Its Applications, page 269.
**
*/

new;
library optmum;

proc mm(b,x);
    retp(b[1]*x./(b[2] + x));
endp;

/*  treated  */
y1 = { 76,   47,   97,  107,  123,  139,  159,  152,  191,  201,  207,  200 };
x1 = { .02,  .02,  .06,  .06,  .11,  .11,  .22,  .22,  .56,  .56,  1.1,  1.1 };

/*  untreated  */
y2 = { 67,   51,   84,   86,   98,  115,  131,  124,  144,  158,  160 };
x2 = { .02,  .02,  .06,  .06,  .11,  .11,  .22,  .22,  .56,  .56,  1.1 };

proc scr1(beta);
  local u;
  u = y1 - beta[1]*x1 ./ (beta[2] + x1);
  retp(u'u);
endp;

proc scr2(beta);
  local u;
  u = y2 - beta[1]*x2 ./ (beta[2] + x2);
  retp(u'u);
endp;

let sv = 100 5;

__output = 0;
{beta1,fmin,g,retcode} = optmum(&scr1,sv);
{beta2,fmin,g,retcode} = optmum(&scr2,sv);
