/*   TSCS Example
**
**  The following is an example of a Gauss program for executing the
**  TSCS module.  Along with the program, results obtained from an
**  analysis of the sample data (i.e., JDATA) are provided.  These data
**  correspond to the data shown in Chapter 11, Table 11.5 of Judge et
**  al. (1988)n  The variable x1 refers to the group (firm), x2
**  corresponds to the cost, and x3 equals the output.
*/

new;
library tscs;

output file = tscs.out reset;

_tsmeth = 1;

{ b_dv,vc_dv,m_dv,b_ec,vc_ec,m_ec } = tscs("jdata","x3","x2","x1");

output off;

data = loadd("jdata");

y = data[.,3];
x = ones(rows(data),1)~data[.,2];

grp = dummy(data[.,1],1|2|3);

y/x;

x = data[.,2]~grp;

y/x;