/*
** Qprog1.prg
**
*/

new;
library pgraph;

alpha = seqa(5,0.1,251);
N = rows(alpha);
x = zeros(N,3);
fmax = zeros(N,1);

let bounds = {0 1e200};
let C[2,3] = 1 1 1 6 9 5;
let D = 40 280;

sv = ones(3,1)/3;

i = 1;
do until i > rows(alpha);
  r = 14|alpha[i]|13;
  {xi,u1,u2,u3,u4,retcode} = QProg(sv,zeros(3,3),r,0,0,-C,-D,bounds);
  x[i,.] = xi';
  fmax[i] = r'xi;
  i = i + 1;
endo;

graphset;
  begwind;
  window(2,2,0);
    _pnum = 2; _paxht = 0.25; _pnumht = 0.25;
    fonts("simplex simgrma"); _plwidth = 5;

  setwind(1);
    _pltype = 6|1|3; _pcolor = 3|6|2;
    xtics(5,30,5,5);
    ytics(-10,50,10,2);
    xlabel("\214\202a\201");
    xy(alpha,x);

  setwind(2);
    ylabel("\214x]1[(\202a\201)");
    _plctrl = -10; _pstype = 5;
    xy(alpha,x[.,1]);

  setwind(3);
    ylabel("\214x]2[(\202a\201)");
    _plctrl = 50; _pstype = 9;
    xy(alpha,x[.,2]);

  setwind(4);
    ylabel("\214x]3[(\202a\201)");
    _plctrl = -10; _psymsiz = 6;
    _pmsgstr = "Ici, les symboles sont\000plus grands";
    _pmsgctl = -10~50~0.45~-40~1~13~0 |
                10~-5~0.25~0~1~12~0 ;
    xy(alpha,x[.,3]);

  graphprt("-c=1 -cf=qprog1.ps");

  endwind;