new;
library optmum,pgraph;

x = rndp(100,1,6.5);

fn negML(lambda) = -sumc(-lambda + x .* ln(lambda) - ln(x!) );

{lambdaML,Logl,g,retcode} = optmum(&negML,1);

proc SML_Logl(lambda);
  local N,nx,Pr,i,Logl;

  rndseed 123;
  N = rndp(1000,1,lambda);
  
  nx = rows(x);
  Pr = zeros(nx,1);

  i = 1;
  do until i > nx;
    Pr[i] = meanc( N .== x[i]);
    i = i + 1;
  endo;

  Logl = ln(Pr+__macheps);
  
  retp( Logl );
endp;

fn SML(lambda) = sumc(SML_Logl(lambda));

Lambda = seqa(0.1,0.1,200);
Logl = zeros(200,1);

i = 1;
do until i > 200;
  Logl[i] = SML(Lambda[i]);
  i = i + 1;
endo;

LambdaSML = Lambda[maxindc(Logl)];

print lambdaML~lambdaSML;


graphset;
  _pdate = ""; _pnum = 2; _pframe = 0; _plwidth = 5;
  fonts("simplex simgrma");
  xlabel("\214\202l\201");
  ylabel("\214Simulated log-likelihood function");
  xtics(0,20,2.5,5);
  ytics(-3500,0,500,2);
  graphprt("-c=1 -cf=sml1.ps");
  xy(lambda,Logl);