new;

declare matrix r, Mu, Sigma;

fn h1(x,y) = sqrt(r^2 - x^2 - y^2);
fn h2(x,y) = -h1(x,y);
  
fn g1(x) = h1(x,0);
fn g2(x) = -g1(x);

proc pdfn3(x,y,z);
  local n,pdf,t,invSigma,i;

  n = rows(z);
  pdf = zeros(n,1);

  t = x|y|0;
  invSigma = invpd(Sigma);

  i = 1;
  do until i > n;
    t[3] = z[i];
    pdf[i] = (t-Mu)'*invSigma*(t-Mu);
    i = i + 1;
  endo;

  retp( exp( -0.5*pdf) / (2*pi)^(3/2) / sqrt(detl) );
endp;

rayon = seqa(0.5,0.5,10);
Pr = zeros(10,2);

Mu = zeros(3,1);
Sigma = eye(3);

i = 1;
do until i > 10;
  _intrec = 0;
  _intord = 40;
  r = rayon[i];
  Pr[i,1] = intgrat3(&pdfn3,r|-r,&g1|&g2,&h1|&h2);
  print /flush i;
  i = i + 1;
endo;

let Mu = 1 -1 2;
let Sigma[3,3] = 1.0  0.5  0.25
                 0.5  1.0  0.15
                 0.25 0.15 1.0;

i = 1;
do until i > 10;
  _intrec = 0;
  _intord = 40;
  r = rayon[i];
  Pr[i,2] = intgrat3(&pdfn3,r|-r,&g1|&g2,&h1|&h2);
  print /flush i;
  i = i + 1;
endo;


output file = sphere1.out reset;

print "=============================================================";
print "           rayon               Probabilit      ";
print "                           Sigma1           Sigma2     ";
print "=============================================================";

call printfmt(rayon~Pr,1);

output off;