/*
**  LUTKEPOHL [1991], Introduction to Multiple Time Series Analysis,
**  Springer-Verlag, Berlin-Heidelberg
**
*/

new;
library ritme;

cls;

load y[92,3] = lutkepoh.asc;
y = ln(y[1:76,.]);

INVEST = y[.,1];
INCOME = y[.,2];
CONSUM = y[.,3];

let names = INVEST INCOME CONSUM;

lag_ = 3;
{lambda,logl,lambda_trace,lambda_max,table} = JohansenTest(y,lag_);
rank_ = 2;
{alpha,beta,Pi_} = JohansenCoint(table,rank_);

lag_ = lag_ - 1;

let __altnam_y = "INV" "INC" "CON";
__altnam_x = 0;
{coeffs,stderr,sigma,u} =  vecm(y,0,Pi_,lag_);

__fmtnv = { "*.*lg " 10 3 };
coeffs = alpha'|coeffs;
__altnam = (0 $+ "L" $+ ftocv(seqa(1,1,rank_),1,0)) | __altnam;

output file = vecm2.out reset;

call printfmt(__altnam~coeffs,0~ones(1,3));

output off;
